from typing import Any, Pattern

from simple_pid import PID

SYSFS_HWMON_BASE: str


class ThermalZone:
    fans: Any = ...
    temp_source: Any = ...
    pid: PID = ...
    factor: float = ...
    name: str = ...
    target: Any = ...
    hwmap: dict = ...
    pyfan: PyFan = ...
    alias_replace: Pattern = ...

    def __init__(self, config: dict, pyfan_parent: PyFan) -> None: ...

    def eval(self) -> None: ...

    def get_temp(self): ...

    def restore(self) -> None: ...

    def setup_pwm(self, value: int = ...) -> None: ...

    def replace_alias(self, path: str): ...

    def build_pwm_path(self, specific: Any): ...

    def write_sysfs(self, path: str, value: Any) -> None: ...

    def read_sysfs(self, path: str): ...

    def set_pwm_mode(self, path: str, value: int = ...) -> None: ...


class PyFan:
    config: dict = ...
    zones: list = ...
    interval: float = ...

    def __init__(self, config: str = ...) -> None: ...

    def __enter__(self): ...

    def __exit__(self, exc_type: Any, exc_val: Any, exc_tb: Any) -> None: ...

    def eval(self) -> None: ...

    @property
    def hwmap(self): ...
